// VolumeControlDlg.h : header file
//

#if !defined(AFX_VOLUMECONTROLDLG_H__C9273A69_4EA0_470B_B026_A3D297A4AA10__INCLUDED_)
#define AFX_VOLUMECONTROLDLG_H__C9273A69_4EA0_470B_B026_A3D297A4AA10__INCLUDED_

#pragma warning(disable: 4786)

#import "..\..\..\common\VCProX.ocx"

using namespace VCProX;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CVolumeControlDlg dialog

class CVolumeControlDlg : public CDialog
{
// Construction
public:
	CVolumeControlDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CVolumeControlDlg)
	enum { IDD = IDD_VOLUMECONTROL_DIALOG };
	CButton	m_RecMute;
	CButton	m_PlayMute;
	CComboBox	m_Rec;
	CComboBox	m_Play;
	CComboBox	m_MixerDevice;
	CComboBox	m_SimplePlayback;
	CComboBox	m_SimpleRecSource;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVolumeControlDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVolumeControlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnSelchangeCombo2();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnSelchangeCombo3();
	afx_msg void OnButton5();
	afx_msg void OnButton6();
	afx_msg void OnButton7();
	afx_msg void OnButton8();
	afx_msg void OnSelchangeCombo4();
	afx_msg void OnSelchangeCombo5();
	afx_msg void OnButton9();
	afx_msg void OnButton10();
	afx_msg void OnButton11();
	afx_msg void OnButton12();
	afx_msg void OnCheck1();
	afx_msg void OnCheck2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	string name;
	//IvcproVolumeControlXPtr m_VControl;
	HexComPtr<HEX_IIID(IvcproVolumeControlX)> m_VControl;
	//IvcproVolumeControl2XPtr m_VControl2;
	HexComPtr<HEX_IIID(IvcproVolumeControl2X)> m_VControl2;
	int playIndex;
	int recIndex;
	void VCInit();
	void VCUninit();

	// simple
	int getSimpleRecVolume();
	int getSimplePlayVolume();
	void setSimpleRecVolume(int value);
	void setSimplePlayVolume(int value);
	void updateRecVolume();
	void updatePlayVolume();

	// full
	int getRecLineVolume();
	int getPlayLineVolume();
	void setRecLineVolume(int value);
	void setPlayLineVolume(int value);
	void updateRecLine();
	void updatePlayLine();

	int getRecConnVolume();
	int getPlayConnVolume();
	void setRecConnVolume(int value);
	void setPlayConnVolume(int value);
	void updateRecConn();
	void updatePlayConn();

	void updateRecMuted();
	void updatePlayMuted();
};

class INT2STR
{
private:
	char m_buffer[64];
public:
	INT2STR(int value, int radix = 10)
	{
		_itoa(value, m_buffer, radix);
	}
	operator const char*() const { return m_buffer; }
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VOLUMECONTROLDLG_H__C9273A69_4EA0_470B_B026_A3D297A4AA10__INCLUDED_)
